unit Play4;

interface

uses play3,p952,sysutils;

PROCEDURE DRAWONPLOTTER(ok:char);

implementation

PROCEDURE DRAWONPLOTTER(ok:char);
const scale=1.0;
var lb1,lb2:string;
    com1:text;
    cf,snf,co,si,bigfactor,norm,tx,ty,tz,dx,dy,mx,my:real;
    nom:string;
    iss,icy,ixshift,i,j,ix,iy,irx,iry:integer;

procedure initplotter(ok:char);
begin
 if ok='p' then assign(com1,'lpt1') else assign(com1,'play.plt');
 rewrite(com1);
 write(com1,chr(27)+'E')   ;       {reset}
 write(com1,chr(27)+'&l1O')   ;    {landscape plotting}
 write(com1,chr(27)+'%0B ') ;      {set HPGL mode}
end;

procedure closeplotter;
begin
 write(com1,chr(27),'%0A');       {set PCL mode}
 write(com1,chr(27)+'&l0O')   ;   {portrait plotting}
 write(com1,chr(27),'&l0H');      {eject page}
 close(com1);
end;

procedure pa(x,y:real);begin  writeln(com1,'pa',round(x),',',round(y),';');end;

procedure pd;begin writeln(com1,'pd;');end;

procedure pu;begin writeln(com1,'pu;');end;

procedure text(x,y:real;txt:string);
begin
   pu;
   pa(x,y);
   pd;
   writeln(com1,'lb ',txt,char(3),';');
   pu;
   pa(x,y);
end;

procedure line(x1,y1,x2,y2:real);
begin
 pu;
 pa(x1,y1);
 pd;
 pa(x2,y2);
 pu;
end;

procedure lineto(x,y:real);
begin
 pd;
 pa(x,y);
 pu;
end;

Procedure limitsploter; var i:integer;
begin
 ax:=xgmp/2/(rxmax-rxmin);ay:=ygmp/2/(rymax-rymin);
 bx:=xgmp/4-ax*rxmin;     by:=ygmp/4-ay*rymin;
 if (rxmax-rxmin)/(rymax-rymin)<xgmp/ygmp then begin
  ax:=ay;
  bx:=xgmp/2-ay*(rxmax+rxmin)/2;
 end;
 if (rxmax-rxmin)/(rymax-rymin)>xgmp/ygmp then begin
  ay:=ax;
  by:=ygmp/2-ax*(rymax+rymin)/2;
 end;
end;

BEGIN
 initplotter(ok);
 limitsploter;write(com1,'sp1;pw 0.1;');
  icy:=1;
  bigfactor:=1;
  if stereo then begin
   icy:=2;
   bigfactor:=0.5;
   cf:=cos(stereoangle*Pi/180);snf:=sin(stereoangle*Pi/180);
  end;

 {stereo-cycles}
 for iss:=1 to icy do begin
 ixshift:=0;
{ if stereo then
 ixshift:=-round((xgmp/4)*stereodistance);}

 if iss=1 then begin
  co:=1;si:=0;
 end else begin
  co:=cf;si:=snf;
  ixshift:=-ixshift;
 end;
 sf:=strtofloat(form2.Edit6.text);
 bigfactor:=bigfactor*sf;
 for i:=1 to nat do begin
  irx:=round(bigfactor*ax*(co*x[i,1]+si*x[i,3])+bx)+ixshift;
  iry:=round((ay*bigfactor*x[i,2]+by));
  for j:=1 to ib[i] do begin
   if bond[i,j]>i then begin
    ix:=round(bigfactor*ax*(x[bond[i,j],1]*co+x[bond[i,j],3]*si)+bx)+ixshift;
    iy:=round(bigfactor*ay*x[bond[i,j],2]+by);
    line(irx,iry,ix,iy);
   end;
  end;
  if nb='y' then begin
   line(irx-50,iry,irx+50,iry);line(irx,iry-50,irx,iry+50);
  end;
  str(i:2,nom);
  if sy='y' then text(irx,iry,at[i]);
  if nb='y' then text(irx,iry,'  '+nom);
  tx:=smx[3*(i-1)+1,mode]*scale*factor;
  ty:=smx[3*(i-1)+2,mode]*scale*factor;
  tz:=smx[3*(i-1)+3,mode]*scale*factor;
  write(com1,'pw 0.5;');
  ix:=round(ax*bigfactor*(co*(x[i,1]+tx)+si*(x[i,3]+tz))+bx)+ixshift;
  iy:=round(ay*bigfactor*(x[i,2]+ty)+by);
  line(irx,iry,ix,iy);
  write(com1,'pw 1.0;');
  ix:=round(ax*bigfactor*(co*(x[i,1]-tx)+si*(x[i,3]-tz))+bx)+ixshift;
  iy:=round(ay*bigfactor*(x[i,2]-ty)+by);
  line(irx,iry,ix,iy);
  write(com1,'pw 0.1;');
 end;

 end;
 {stereo-cycle}

 if form2.checkbox1.checked then begin
  {dipole moments:}


  ix:=round(ax*(0{dox})+bx)+ixshift;iy:=round(ay*(0{doy})+by);
  irx:=ix+round(bigfactor*ax*10*(co*d[mode,1]+si*d[mode,3]));
  iry:=iy+round(bigfactor*ay*d[mode,2]*10);
  line(ix,iy,irx,iry);
  write(com1,'pw 0.1;');
  irx:=ix+round(bigfactor*ax*1e5*(co*m[mode,1]+si*m[mode,3]));
  iry:=iy+round(bigfactor*ay*m[mode,2]*1e5);
  line(ix,iy,irx,iry);
 end;

if nb='y' then begin



 write(com1,'pw 0.3;');
 ix:=round(ax*(xm)+bx);iy:=round(ay*(ym)+by);
 str(e[mode]:10:2,nom);
 text(xgmp/2,ygmp/16,nom);
 str(mode:4,nom);
 text(xgmp/4,ygmp/16,nom);
 str(ds[mode]:10:5,nom);
 nom:='D = '+nom+' D^2';
 text(0.75*xgmp,ygmp/16,nom);
 str(rs[mode]*1e8:10:5,nom);
 nom:='R = '+nom+' 1e-8 D^2';
 text(0.75*xgmp,ygmp/32,nom);
end;
 if ok='P' then begin
  write(com1,'pw 0.4;');
  ix:=round(ax*(xm)+bx);iy:=round(ay*(ym)+by);
  irx:=ix+round(ax*20*d[mode,1]);iry:=iy+round(ay*d[mode,2]*20);
  line(ix,iy,irx,iry);
  write(com1,'pw 0.15;');
  irx:=ix+round(ax*1e5*m[mode,1]);iry:=iy+round(ay*m[mode,2]*1e5);
  line(ix,iy,irx,iry);
  write(com1,'sp1;');
 end;
 closeplotter;
END;

end.