Unit Play3;
{$J+}
interface
uses sysutils,graphics,oform1,math;
const  planck=6.6260755e-34;hartree=219470.0;
       electron=1.60217733e-19;light=2.99792458e8;bohr=0.52917705993;
       au=2.1947e5;
       ninp=7;
       natincentre=5;
       xgmp=10000;ygmp=8000;{plotter scale}
       energyerror:real=0.1;
       stereoangle=-5;
       stereodistance:real=0.75;
       nb:char='y';
       sy:char='y';
       factor:real=1.0;
       stereo:boolean=false;
       force:boolean=false;
       totalzoom:real=1;
       lmove:boolean=false;
       MENDELEV=89;
       menold=5;
       atsyold:array[0..menold]of string[2]=('Du',
       ' C',' O',' N',' H',' S');

       atsy:array[0..MENDELEV]of string[2]=('Du',' H','He','Li','Be',' B',' C',' N',' O',' F','Ne',
     'Na','Mg','Al','Si',' P',' S','Cl','Ar',
     ' K','Ca','Sc','Ti',' V','Cr','Mn','Fe','Co','Ni','Cu','Zn',
               'Ga','Ge','As','Se','Br','Kr',
     'Rb','Sr',' Y','Zr','Nb','Mo','Tc','Ru','Rh','Pd','Ag','Cd',
               'In','Sn','Sb','Te',' I','Xe',
     'Cs','Ba','La',
                    'Ce','Pr','Nd','Pm','Sm','Eu','Gd','Tb','Dy','Ho',
                    'Er','Tm','Yb','Lu',
     'Hf','Ta',' W','Re','Os','Ir','Pt','Au','Hg',
               'Tl','Pb','Bi','Po','At','Rn',
     'Fr','Ra','Ac');
      amas:array[0..MENDELEV]of real=(1.0,1.008,4.003,
       6.941, 9.012,   10.810,12.011,14.007,15.999,18.998,20.179,
      22.990,24.305,   26.981,28.086,30.974,32.060,35.453,39.948,
      39.098,40.080,44.956,47.900,50.941,51.996,54.938,55.847,
      58.933,58.700,63.546,65.380,
                       69.720,72.590,74.922,78.960,79.904,83.800,
      85.468,87.620,88.906,91.220,92.906,95.940,98.906,101.070,
      102.906,106.400,107.868,112.410,
                      114.82,118.69,121.75,127.600,126.905,131.300,
      132.905,137.330,138.906,
                      140.120,140.908,144.240,145.000,150.400,
      151.960,157.250,158.925,162.500,164.930,167.260,168.934,
      173.040,174.970,
      178.490,180.948,183.850,186.207,190.200,192.220,195.090,
      196.967,207.590,204.370,207.200,208.980,210.000,210.001,
      222.02,
      223.000,226.025,227.028);
     ljpeg:boolean=false;
     lbmp:boolean=false;
     lagif:boolean=false;

type
 real=single;
 vector=array[1..3] of real;

 xvc=array of array of real;

var {GLobal variables}
    mode,n1,n2,nint,nat3,iss,nat,n3,
    {mode:active mode; nint:total number of modes}
    itx,ity,xgm,ygm,nwv,xsmouse,shiftx,shifty,ysmouse,xomouse,yomouse,maco,axis:integer;
    CurrentMatrix: array[1..3] of array[1..3] of real;
    GlobalShift: array[1..3] of real;
    rxmin,rxmax,rymin,rymax:real;
    isstr:array[1..ninp] of string;
    ior:word;
    ok,ori:char;
    ax,bx,ay,by,xm,ym,zm,sf,dox,doy:real;
    origine:string[18];
    shift:array[1..2] of real;
    cfv:integer;
    p1,p2:integer;
    lastkey:integer;
    itype:integer;
    ma:real;
    gbmp:tbitmap;
    gc:vector;

    {dynamic:}
    x,smx,smf,sp8,spec:xvc;
    rr,dr,ri,pr,rs,ds,e:array of real;
    m,d:array of vector;
    move:array of real;
    zmass,q:array of real;
    kind:array of integer;
    at:array of string[2];
    bond:array of array of integer;
    ib:array of integer;


Procedure Oldpar;
Procedure Newpar;
Procedure Savescr;
Procedure Checkscr;
Procedure Reads1;
Procedure Reads2;
Procedure Reads3;
Procedure Reads4;
Procedure Reads5;
Procedure Reads6;
Procedure Reads7;
Procedure Reads9;
Procedure Reads10;
Procedure Reads11;
Procedure Reads12;
Procedure Reads13;
Procedure Reads14;
Procedure outputsc;
Procedure bondtable;
Procedure bondtablenew;
Procedure outputtable;
procedure outputxyz;

implementation
uses       dialogs,p952,unit1;
var fx:textfile;
 x1,x2,x3:real;

Procedure Oldpar;
var fv:textfile;filename,tf:string;f:tsearchrec;
begin
 iss:=1;
 ori:='D';
{$IFDEF MSWINDOWS}tf:='c:\play.par';{$ENDIF}
{$IFDEF LINUX}tf:='play.par';{$ENDIF}
 if findfirst(tf,faanyfile,f)<>0 then exit;
 assignfile(fv,tf);
 reset(fv);
 readln(fv,filename);
 if ExtractFileDir(FileName)<>'' then form2.opendialog1.initialdir:=ExtractFileDir(FileName);
 readln(fv,itype);
 form2.ftry1.checked:=false;
 form2.ftryold1.checked:=false;
 form2.cadpac41.checked:=false;
 form2.cadpac51.checked:=false;
 form2.gaussian901.checked:=false;
 form2.gaussian941.checked:=false;
 form2.gaussian981.checked:=false;
 form2.shortg941.checked:=false;
 form2.mopac1.checked:=false;
 case itype of 1:form2.ftry1.checked:=true;
               2:form2.ftryold1.checked:=true;
               3:form2.cadpac41.checked:=true;
               4:form2.cadpac51.checked:=true;
               5: form2.gaussian901.checked:=true;
               6: form2.gaussian941.checked:=true;
               7: form2.gaussian981.checked:=true;
               8: form2.shortg941.checked:=true;
               9: form2.mopac1.checked:=true;
 else form2.ftry1.checked:=true end;
 closefile(fv);
 end;

 Procedure checkscr;
 var ff:textfile;
 ic:longint;
 ac:real;
 begin
 assignfile(ff,'c:\play.scr');
 {$I-}
 reset(ff);
 {$I+}
 if IOresult=0 then begin
{$I-}  readln(ff,ic); {$I+}  if IOresult=0 then begin oform.checkbox1.checked:=ic=1;end;
{$I-}  readln(ff,ic); {$I+}  if IOresult=0 then begin oform.checkbox2.checked:=ic=1;end;
{$I-}  readln(ff,ic); {$I+}  if IOresult=0 then begin oform.checkbox3.checked:=ic=1;end;
{$I-}  readln(ff,ic); {$I+}  if IOresult=0 then begin oform.checkbox4.checked:=ic=1;end;
{$I-}  readln(ff,ic); {$I+}  if IOresult=0 then begin oform.checkbox8.checked:=ic=1;end;
{$I-}  readln(ff,ic); {$I+}  if IOresult=0 then begin oform.panel1.color:=ic;end;
{$I-}  readln(ff,ic); {$I+}  if IOresult=0 then begin oform.panel2.color:=ic;end;
{$I-}  readln(ff,ic); {$I+}  if IOresult=0 then begin oform.panel3.color:=ic;end;
{$I-}  readln(ff,ic); {$I+}  if IOresult=0 then begin oform.panel4.color:=ic;end;
{$I-}  readln(ff,ic); {$I+}  if IOresult=0 then begin oform.panel5.color:=ic;end;
{$I-}  readln(ff,ic); {$I+}  if IOresult=0 then begin oform.panel6.color:=ic;end;
{$I-}  readln(ff,ic); {$I+}  if IOresult=0 then begin oform.panel7.color:=ic;end;
{$I-}  readln(ff,ic); {$I+}  if IOresult=0 then begin oform.panel8.color:=ic;end;
{$I-}  readln(ff,ic); {$I+}  if IOresult=0 then begin oform.edit1.text:=inttostr(ic);end;
{$I-}  readln(ff,ic); {$I+}  if IOresult=0 then begin oform.edit2.text:=inttostr(ic);end;
{$I-}  readln(ff,ic); {$I+}  if IOresult=0 then begin oform.edit3.text:=inttostr(ic);end;
{$I-}  readln(ff,ic); {$I+}  if IOresult=0 then begin oform.edit4.text:=inttostr(ic);end;
{$I-}  readln(ff,ac); {$I+}  if IOresult=0 then begin oform.edit5.text:=floattostrf(ac,fffixed,10,2);end;
{$I-}  readln(ff,ac); {$I+}  if IOresult=0 then begin oform.edit6.text:=floattostrf(ac,fffixed,10,2);end;
{$I-}  readln(ff,ic); {$I+}  if IOresult=0 then begin oform.edit7.text:=inttostr(ic);end;
{$I-}  readln(ff,ic); {$I+}  if IOresult=0 then begin oform.edit8.text:=inttostr(ic);end;
{$I-}  readln(ff,ac); {$I+}  if IOresult=0 then begin oform.edit9.text:=floattostrf(ac,fffixed,10,1);end;
{$I-}  readln(ff,ac); {$I+}  if IOresult=0 then begin oform.edit10.text:=floattostrf(ac,fffixed,10,1);end;
{$I-}  readln(ff,ic); {$I+}  if IOresult=0 then begin oform.edit11.text:=inttostr(ic);end;
{$I-}  readln(ff,ic); {$I+}  if IOresult=0 then begin oform.edit12.text:=inttostr(ic);end;
{$I-}  readln(ff,ic); {$I+}  if IOresult=0 then begin if ic=1 then oform.radiobutton1.checked:=true;if ic=2 then oform.radiobutton2.checked:=true;if ic=3 then oform.radiobutton3.checked:=true;if ic=4 then oform.radiobutton4.checked:=true;end;
{$I-}  readln(ff,ic); {$I+}  if IOresult=0 then oform.radiogroup1.itemindex:=ic;
{$I-}  readln(ff,ic); {$I+}  if IOresult=0 then oform.radiogroup2.itemindex:=ic;
  close(ff);
 end;
end;

Procedure Savescr;
var ff:textfile;
begin
 assignfile(ff,'c:\play.scr');
 rewrite(ff);
 if oform.checkbox1.checked then writeln(ff,'1') else writeln(ff,'0');
 if oform.checkbox2.checked then writeln(ff,'1') else writeln(ff,'0');
 if oform.checkbox3.checked then writeln(ff,'1') else writeln(ff,'0');
 if oform.checkbox4.checked then writeln(ff,'1') else writeln(ff,'0');
 if oform.checkbox8.checked then writeln(ff,'1') else writeln(ff,'0');
 writeln(ff,oform.panel1.color);
 writeln(ff,oform.panel2.color);
 writeln(ff,oform.panel3.color);
 writeln(ff,oform.panel4.color);
 writeln(ff,oform.panel5.color);
 writeln(ff,oform.panel6.color);
 writeln(ff,oform.panel7.color);
 writeln(ff,oform.panel8.color);
 writeln(ff,oform.edit1.text);
 writeln(ff,oform.edit2.text);
 writeln(ff,oform.edit3.text);
 writeln(ff,oform.edit4.text);
 writeln(ff,oform.edit5.text);
 writeln(ff,oform.edit6.text);
 writeln(ff,oform.edit7.text);
 writeln(ff,oform.edit8.text);
 writeln(ff,oform.edit9.text);
 writeln(ff,oform.edit10.text);
 writeln(ff,oform.edit11.text);
 writeln(ff,oform.edit12.text);
 if oform.radiobutton1.checked then writeln(ff,'1');
 if oform.radiobutton2.checked then writeln(ff,'2');
 if oform.radiobutton3.checked then writeln(ff,'3');
 if oform.radiobutton4.checked then writeln(ff,'4');
 writeln(ff,oform.radiogroup1.itemindex);
 writeln(ff,oform.radiogroup2.itemindex);
 closefile(ff);
end;


Procedure Newpar;
var fv:textfile;
begin
{$IFDEF MSWINDOWS}
 assignfile(fv,'c:\play.par');
 {$ENDIF}
 {$IFDEF LINUX}
 assignfile(fv,'play.par');
 {$ENDIF}
 rewrite(fv);
 writeln(fv,form2.opendialog1.filename);
 itype:=0;
 if form2.ftry1.checked then itype:=1;
 if form2.ftryold1.checked then itype:=2;
 if form2.cadpac41.checked then itype:=3;
 if form2.cadpac51.checked then itype:=4;
 if form2.gaussian901.checked then itype:=5;
 if form2.gaussian941.checked then itype:=6;
 if form2.gaussian981.checked then itype:=7;
 if form2.shortg941.checked then itype:=8;
 if form2.mopac1.checked then itype:=9;
 writeln(fv,itype);
 closefile(fv);
end;


Function linmol(var x:xvc):boolean;
var linear:boolean;i,j,k,l:integer;a:real;
Begin
 linear:=false;
 for i:=1 to 3 do begin
  a:=0.0;
  j:=i+1;if j=4 then j:=1;
  k:=j+1;if k=4 then k:=1;
  for l:=1 to nat do a:=a+sqr(x[l,j])+sqr(x[l,k]);
  if a<0.01 then linear:=true;
 end;
 if linear then form2.label3.visible:=true;
 linmol:=linear;
end;

Procedure tmm(n:integer; var n1,n2:integer);
begin
  n1:=1;
  form2.edit3.text:=inttostr(n);
  {$IFDEF MSWINDOWS}
  form2.spinedit1.minValue:=1;
  form2.spinedit1.maxValue:=n;
  {$ENDIF}
  {$IFDEF LINUX}
  form2.spinedit1.min:=1;
  form2.spinedit1.max:=n;
  {$ENDIF}
  form2.spinedit1.Value:=n;
  n2:=n;
end;

Procedure allocatew(nat,nm:integer);
begin
 {remember that indices run form zero:}
 setlength(smx,3*nat+1,nm+1);
 setlength(smf,3*nat+1,nm+1);
 setlength(x,nat+1,3+1);
 setlength(sp8,nm+1,9+1);
 setlength(rr,nm+1);
 setlength(dr,nm+1);
 setlength(ri,nm+1);
 setlength(pr,nm+1);
 setlength(rs,nm+1);
 setlength(ds,nm+1);
 setlength(e,nm+1);
 setlength(m,nm+1);
 setlength(d,nm+1);
 setlength(x,nat+1,3+1);
 setlength(move,nat+1);
 setlength(zmass,nat+1);
 setlength(q,nat+1);
 setlength(kind,nat+1);
 setlength(at,nat+1);
 setlength(bond,nat+1,8+1);
 setlength(ib,nat+1);
 setlength(spec,3*nat+1,2+1);
 n3:=3*nat;
end;

Procedure Reads1;{CADPAC 4}
label l1,l2,l4,l5,l6,l8;
var namet:string[78];key:string[18];slovo:string[15];letter:string[1];
imode,ifound,ico,i,j,k,jj:integer;
 frame:string[5];
 element:string[11];id:string[6];
 center:boolean;
 a,b,c:real;ori1:string[5];
begin
 ifound:=0;
l1:
 {$I-}readln(filvar,key);if IOresult<>0 then begin
{  writeln(' Intensity output not found, program terminated');}
  halt;
 end;       {$I+}
  {       1234567890123456789012345678901234567890}
  if key='0RUNTYP = INTENSIT' then begin
   ifound:=ifound+1;
   repeat
    readln(filvar,key)
   until key='   MOLECULAR GEOME';
   i:=0;
   repeat
    readln(filvar,key);
    i:=i+1;
   until key='   MOLECULAR GEOME';
   nat:=i-5;
   allocatew(nat,nat*3);
   readln(filvar);readln(filvar);
   for i:=1 to nat do readln(filvar,kind[i],x[i,1],x[i,2],x[i,3]);
 l2:readln(filvar,slovo);
   if slovo='          Trans' then begin
    for i:=1 to 5 do readln(filvar);
    imode:=0;
    i:=0;
    l8:imode:=imode+1;
    i:=i+1;
    read(filvar,e[imode]);
    if (imode<3*nat) and (i<8) then  goto l8;
    readln(filvar);readln(filvar);readln(filvar);
    for j:=1 to nat do begin
     read(filvar,id,element);
     for jj:=1 to i do read(filvar,smx[(j-1)*3+1,imode-i+jj]);
     readln(filvar);kind[j]:=0;at[j]:='X ';
     if element='CARBON    x' then begin kind[j]:=1;at[j]:='C ';end;
     if element='OXYGEN    x' then begin kind[j]:=2;at[j]:='O ';end;
     if element='HYDROGEN  x' then begin kind[j]:=4;at[j]:='H ';end;
     if element='NITROGEN  x' then begin kind[j]:=3;at[j]:='N ';end;
     if element='FLUORINE  x' then begin kind[j]:=10;at[j]:='F ';end;
     if element='CHLORINE  x' then begin kind[j]:=11;at[j]:='Cl';end;
     if element='SULPHUR   x' then begin kind[j]:=5 ;at[j]:='S ';end;
     if element='PHOSPHOR  x' then begin kind[j]:=9 ;at[j]:='P ';end;
     if kind[j]=0 then showmessage('unknown atom '+inttostr(j)+' '+element);
     read(filvar,id,element);
     for jj:=1 to i do read(filvar,smx[(j-1)*3+2,imode-i+jj]);
     readln(filvar);
     read(filvar,id,element);
     for jj:=1 to i do read(filvar,smx[(j-1)*3+3,imode-i+jj]);
     readln(filvar);
    end;
    if imode<3*nat then begin
     for i:=1 to 5 do readln(filvar);i:=0;goto l8;
    end;
   end;

     {       1234567890123456789012345678901234567890}
   if slovo='         Normal' then begin
    readln(filvar);readln(filvar);
    for j:=1 to imode do begin
     if abs(e[j])>0.05 then begin readln(filvar,a,d[j,1],d[j,2],d[j,3]);
      if abs(a-e[j])>energyerror then begin
       halt;
      end;
     end;
    end;
    l4:
    form2.label9.caption:=inttostr(imode)+'modes found';
    l5:
    readln(filvar,frame);
    ori1:=' '+copy(origine,1,4);
    if frame=ori1 then begin
     for i:=1 to 4 do readln(filvar);
     for i:=1 to imode do begin
      if abs(e[i])>0.05 then begin
       readln(filvar,slovo,a,a,b,c);
       readln(filvar,slovo,m[i,1],m[i,2],m[i,3]);
       m[i,1]:=m[i,1]+a;m[i,2]:=m[i,2]+b;m[i,3]:=m[i,3]+c;
       readln(filvar);
      end;
     end;
     goto l6;
    end;
    goto l5;
   end;{normal modes}
   goto l2;
 end;    {if intensity found}
 goto l1;
 l6:
 closefile(filvar);
 nint:=imode;
end;

Procedure Reads2;   {CADPAC5}
label l1,l6,l8,l2,l3,l4,l5,l41,l51;
var namet:string[78];key:string[40];letter:string[1];
 s10:string[10];s15:string[15];s12:string[12];
 istart,ifound,ico,i,j,k,jj,idum:integer;a,b,c,en:real;
 frame:string[5];
 element:string[10];id:string[4];
 center:boolean;
 imode0,ideg,imode,jn:integer;
 adum,a1,a2,a3,amin:real;
 linear,smat,geo:boolean;
begin
 ifound:=0;
 geo:=false;
 smat:=false;
l1:
   if eof(filvar) then begin
    form2.caption:='no output found';
    goto l6;
   end;
   readln(filvar,key);

   if copy(key,13,8)='INTENSIT' then begin
     ifound:=ifound+1;
   end;
   if copy(key,2,16)='RUN TYPE = FORCE' then force:=true;
   if ifound>1 then begin
    goto l6;
   end;

   if  copy(key,26,6)='New Mo' then begin
    geo:=true;
    for i:=1 to 2 do readln(filvar);
    i:=0;
    assign(fx,'tem.scr');
    rewrite(fx);
    repeat
     i:=i+1;
     {$I-}
     readln(filvar,s10,s10,x1,x2,x3);
     writeln(fx,x1,' ',x2,' ',x3);
     {$I+}
    until (IOresult<>0);
    nat:=i-1;
    close(fx);
    allocatew(nat,nat*3);
    reset(fx);
    for i:=1 to nat do readln(fx,x[i,1],x[i,2],x[i,3]);
    close(fx);
    for i:=1 to nat do begin
     for j:=1 to 3 do x[i,j]:=x[i,j]*bohr;
    end;
    form2.label2.visible:=true;
    form2.label2.caption:=inttostr(nat);
    linear:=linmol(x);
    if linear then n2:=3*nat-5 else n2:=3*nat-6;
    goto l1;
   end;

   if (copy(key,32,9)='Molecular') and (not(force) )then begin
    geo:=true;
    for i:=1 to 2 do readln(filvar);
    i:=0;
    assign(fx,'tem.scr');
    rewrite(fx);
    repeat
     i:=i+1;
     {$I-}
     readln(filvar,s10,s10,x1,x2,x3);
       writeln(fx,x1,' ',x2,' ',x3);
     {$I+}
    until IOresult<>0;
    nat:=i-1;
       close(fx);
    allocatew(nat,nat*3);
    reset(fx);
    for i:=1 to nat do readln(fx,x[i,1],x[i,2],x[i,3]);
    close(fx);
    for i:=1 to nat do begin
     for j:=1 to 3 do x[i,j]:=x[i,j]*bohr;
    end;
    form2.label2.visible:=true;
    form2.label2.caption:=inttostr(nat);
    goto l1;
   end;

   if  copy(key,2,10)='Geometry, ' then begin
    geo:=true;
    for i:=1 to 5 do readln(filvar);
    i:=0;
    assign(fx,'tem.scr');
    rewrite(fx);
    repeat
     i:=i+1;
     {$I-}
     readln(filvar,s15,a,x1,x2,x3);
       writeln(fx,x1,' ',x2,' ',x3);
     {$I+}
    until IOresult<>0;
    nat:=i-1;
       close(fx);
    allocatew(nat,nat*3);
    reset(fx);
    for i:=1 to nat do readln(fx,x[i,1],x[i,2],x[i,3]);
    close(fx);
    for i:=1 to nat do begin
     for j:=1 to 3 do x[i,j]:=x[i,j]*bohr;
    end;
    form2.label2.visible:=true;
    form2.label2.caption:=inttostr(nat);
    goto l1;
   end;

   if copy(key,2,14)='Atomic Charges' then begin
    for i:=1 to nat do readln(filvar,s10,s10,q[i]);
    goto l1;
   end;

   if copy(key,2,22)='OPTIMIZATION CONVERGED' then begin
    readln(filvar);readln(filvar);readln(filvar,s15,a);
    goto l1;
   end;

   if (copy(key,2,14)='Transformation') then begin
    linear:=linmol(x);
    if smat then begin
    end;

    smat:=true;
    if not(geo) then begin
     form2.caption:='Geometry not found !';
     halt;
    end;

    tmm(3*nat,n1,n2);
    for i:=1 to 3 do readln(filvar);
    imode:=0;
    i:=0;
    l8:imode:=imode+1;
    i:=i+1;
    read(filvar,adum);
    if (imode<=n2) and (imode>=n1) then e[imode-n1+1]:=adum;
    if (imode<3*nat) and (i<6) then  goto l8;
    readln(filvar);readln(filvar);readln(filvar);
    for j:=1 to nat do begin
     read(filvar,id,element);
     for jj:=1 to i do begin
      read(filvar,adum);
      if (imode-i+jj>=n1) and (imode-i+jj<=n2) then
      smx[(j-1)*3+1,imode-i+jj-n1+1]:=adum;
     end;
     readln(filvar);kind[j]:=0;at[j]:='X ';
     if element='CARBON   x' then begin kind[j]:=1;at[j]:='C ';end;
     if element='OXYGEN   x' then begin kind[j]:=2;at[j]:='O ';end;
     if element='HYDROGEN x' then begin kind[j]:=4;at[j]:='H ';end;
     if element='NITROGEN x' then begin kind[j]:=3;at[j]:='N ';end;
     if element='FLUORINE x' then begin kind[j]:=10;at[j]:='F ';end;
     if element='CHLORINE x' then begin kind[j]:=11;at[j]:='Cl';end;
     if element='SULPHUR  x' then begin kind[j]:=5 ;at[j]:='S ';end;
     if element='PHOSPHOR x' then begin kind[j]:=9 ;at[j]:='P ';end;
     if kind[j]=0 then begin
      if copy(element,1,1)='C' then begin kind[j]:=1;at[j]:='C ';end;
      if copy(element,1,1)='O' then begin kind[j]:=2;at[j]:='O ';end;
      if copy(element,1,1)='H' then begin kind[j]:=4;at[j]:='H ';end;
      if copy(element,1,1)='N' then begin kind[j]:=3;at[j]:='N ';end;
      if kind[j]=0 then showmessage('unknown atom '+inttostr(j)+' '+element);
     end;
     read(filvar,id,element);
     for jj:=1 to i do begin
      read(filvar,adum);
      if (imode-i+jj>=n1) and (imode-i+jj<=n2) then
      smx[(j-1)*3+2,imode-i+jj-n1+1]:=adum;
     end;
     readln(filvar);
     read(filvar,id,element);
     for jj:=1 to i do begin
      read(filvar,adum);
      if (imode-i+jj>=n1) and (imode-i+jj<=n2) then
      smx[(j-1)*3+3,imode-i+jj-n1+1]:=adum;
     end;
     readln(filvar);
    end;{j=1,nat}
    if imode<3*nat then begin
     for i:=1 to 3 do readln(filvar);i:=0;goto l8;
    end;
    imode0:=imode;
    nint:=n2-n1+1;
    imode:=nint;

   end;{S-matrix}

   if copy(key,2,10)='RAMAN DATA' then begin
    readln(filvar);readln(filvar);
    l2:
    readln(filvar,a,b,b,b);
    {find closest frequency:}
    if abs(a-e[1])<energyerror then begin
     ri[1]:=b;
     for i:=2 to imode do readln(filvar,a,a,a,ri[i]);
     goto l3;
    end;
    goto l2;
    l3:
   end;

   if (copy(key,2,11)='Normal mode') and geo then begin
    readln(filvar);
    readln(filvar);
    l4:
    readln(filvar,a,d[1,1],d[1,2],d[1,3],ds[1]);
    {find closest frequency:}
    istart:=0;
    repeat
     istart:=istart+1;
    until e[istart]>energyerror;

    if abs(a-e[istart])<energyerror then begin
     d[istart,1]:=d[1,1];d[istart,2]:=d[1,2];d[istart,3]:=d[1,3];ds[istart]:=ds[1];
     for i:=istart+1 to imode do
     {$I-}
     readln(filvar,a,d[i,1],d[i,2],d[i,3],ds[i]);
     {$I+}
     if IOresult<>0 then goto l5;
     goto l5;
    end;
    goto l4;
    l5:
   end;{dipoles}

   if copy(key,2,18)=origine then begin
    readln(filvar);readln(filvar);readln(filvar);readln(filvar);
    l41:
    readln(filvar,s12,en,a1,a2,a3);
    readln(filvar,s12,   a ,b ,c );
    readln(filvar);
    {find closest frequency:}
    istart:=0;
    repeat
     istart:=istart+1;
    until e[istart]>energyerror;
    if abs(en-e[istart])<energyerror then begin
     m[istart,1]:=a1+a;m[istart,2]:=a2+b;m[istart,3]:=a3+c;
     rs[istart]:=m[istart,1]*d[istart,1]+m[istart,2]*d[istart,2]+m[istart,3]*d[istart,3];
     for i:=istart+1 to imode do begin
      readln(filvar,s12,en,a1,a2,a3);
      readln(filvar,s12,   a ,b ,c );
      readln(filvar);
      m[i,1]:=a1+a;m[i,2]:=a2+b;m[i,3]:=a3+c;
      rs[i]:=m[i,1]*d[i,1]+m[i,2]*d[i,2]+m[i,3]*d[i,3];
     end;
     goto l51;
    end;
    goto l41;
    l51:
   end;
 goto l1;
 l6:

end;
procedure setatomlb(nat:integer);
begin
 form2.label2.visible:=true;
 form2.label2.caption:=inttostr(nat)+' atoms';
end;

Procedure Reads3;{Gaussian 90}
label l1,l6,l8;
var namet:string[78];key:string[40];letter:string[1];
 s10:string[10];s15:string[15];
 ifound,imode,ico,i,j,jj:integer;a,b,c:real;
 frame:string[5];origine:string[5];
 id:string[4];s7:string[7];s22:string[22];
 element:integer;
begin
 ifound:=0;
l1:
   if eof(filvar) then begin
    if ok='n' then halt;
    goto l6;
   end;
   readln(filvar,key);
{                       1234567890123456789012345678901234567890}
   if  copy(key,20,20)='Standard orientation' then begin
    for i:=1 to 4 do readln(filvar);
    i:=0;
    assign(fx,'tem.scr');
    rewrite(fx);
    repeat
     i:=i+1;
     {$I-}
     readln(filvar,j,j,x1,x2,x3);
     writeln(fx,j,' ',x1,' ',x2,' ',x3);
     {$I+}
    until (kind[i]=0) or (IOresult<>0);
    nat:=i-1;
    close(fx);
    allocatew(nat,nat*3);
    reset(fx);
    for i:=1 to nat do readln(fx,kind[i],x[i,1],x[i,2],x[i,3]);
    close(fx);

    setatomlb(nat);
    for i:=1 to nat do q[i]:=0.0;
    for j:=1 to nat do begin
     element:=kind[j];kind[j]:=0;
     at[j]:='X ';
     if element=6  then begin kind[j]:=1;at[j]:='C ';end;
     if element=8  then begin kind[j]:=2;at[j]:='O ';end;
     if element=1  then begin kind[j]:=4;at[j]:='H ';end;
     if element=7  then begin kind[j]:=3;at[j]:='N ';end;
     if element=9  then begin kind[j]:=10;at[j]:='F ';end;
     if element=17 then begin kind[j]:=11;at[j]:='Cl';end;
     if element=16 then begin kind[j]:=5 ;at[j]:='S ';end;
     if element=15 then begin kind[j]:=9 ;at[j]:='P ';end;
     if kind[j]=0 then showmessage('unknown atom '+inttostr(i)+' '+inttostr(element));
    end;
   end;
   {                  1234567890123456789012345678901234567890}
   if copy(key,2,20)='Total atomic charges' then begin
    readln(filvar);
    for i:=1 to nat do readln(filvar,s7,q[i]);
   end;
     {                1234567890123456789012345678901234567890}
   if copy(key,2,20)='Initial convergence ' then begin
    readln(filvar,s10,s10,a);
   end;
   {                  1234567890123456789012345678901234567890}
   if copy(key,1,25)='0Harmonic frequencies (cm' then begin
    for i:=1 to 4 do readln(filvar);
    imode:=0;
    i:=0;
    l8:imode:=imode+1;
    i:=i+1;
    if i=1 then read(filvar,s22);
    read(filvar,e[imode]);
    if (imode<3*nat-6) and (i<5) then  goto l8;
    for j:=1 to 3 do readln(filvar);
    read(filvar,s22);for j:=1 to i do read(filvar,dr[imode-i+j]);readln(filvar);
    read(filvar,s22);for j:=1 to i do read(filvar,ri[imode-i+j]);readln(filvar);
    read(filvar,s22);for j:=1 to i do read(filvar,pr[imode-i+j]);readln(filvar);
    readln(filvar);
    for j:=1 to 3*nat do begin
     read(filvar,s22);for jj:=1 to i do read(filvar,smx[j,imode-i+jj]);
     readln(filvar);
    end;
    if imode<3*nat-6 then begin
     for i:=1 to 2 do readln(filvar);i:=0;goto l8;
    end;
    goto l6;
   end;{S-matrix}
   goto l1;
 l6:
 nint:=imode;
end;

Procedure Reads4;{DeFT}
label l1,l6;
var namet:string[78];key:string[40];letter:string[1];
 s10:string[10];s15:string[15];
 imd,ifound,ico,i,j,k,l,jj:integer;a,b,c,step:real;
 frame:string[5];origine:string[5];
 id:string[4];
 dipole:boolean;
 adum:real;
 dx:array[0..600] of vector;
 imode,nmin,nmax,ims,idum:integer;
 s2:string[2];
begin
 ifound:=0;dipole:=false;
 imode:=0;ims:=0;step:=0.0025/bohr;{now step in a.u.}
 imd:=0;
l1:
   if eof(filvar) then begin
    goto l6;
   end;
   readln(filvar,key);
   {                   1234567890123456789012345678901234567890}
   if  copy(key,2,21)='cartesian coordinates' then begin
    readln(filvar);
    i:=0;
    assign(fx,'tem.scr');
    rewrite(fx);
    repeat
     i:=i+1;
     {$I-}
     readln(filvar,ok,s2,x1,x2,x3);
     writeln(fx,s2,' ',x1,' ',x2,' ',x3);
     readln(filvar);readln(filvar);
     {$I+}
    until (at[i]='  ') or (IOresult<>0);
    nat:=i-1;
    close(fx);
    allocatew(nat,nat*3);
    reset(fx);
    for i:=1 to nat do readln(fx,at[i],x[i,1],x[i,2],x[i,3]);
    close(fx);

    setatomlb(nat);
    for i:=1 to nat do q[i]:=0.0;
    if linmol(x) then tmm(3*nat-5,nmin,nmax) else tmm(3*nat-6,nmin,nmax);
    for j:=1 to nat do begin
     kind[j]:=0;
     if at[j]='c ' then begin kind[j]:=1;at[j]:='C ';end;
     if at[j]='o ' then begin kind[j]:=2;at[j]:='O ';end;
     if at[j]='h ' then begin kind[j]:=4;at[j]:='H ';end;
     if at[j]='n ' then begin kind[j]:=3;at[j]:='N ';end;
     if at[j]='f ' then begin kind[j]:=10;at[j]:='F ';end;
    end;
    goto l1;
   end;
   {                  1234567890123456789012345678901234567890}
   if copy(key,2,11)='normal mode' then begin
    readln(filvar);
    imode:=imode+1;
    if (imode>nmax) or (imode<nmin) then goto l1;
    ims:=ims+1;
    readln(filvar,s15,s15,e[ims]);
    for i:=1 to 4 do readln(filvar);
    for j:=1 to nat do begin
     read(filvar,idum);
     for i:=1 to 3 do read(filvar,smx[(j-1)*3+i,ims]);
     readln(filvar);
    end;
    imode:=ims;
   end;{S-matrix}
   {                  1234567890123456789012345678901234567890}
   if copy(key,2,15)='dipole moment :' then begin
    readln(filvar);
    readln(filvar,s15,s15,s15,dx[0,1]);
    readln(filvar,s15,s15,s15,dx[0,2]);
    readln(filvar,s15,s15,s15,dx[0,3]);
    dipole:=true;
   end;
   {                  1234567890123456789012345678901234567890}
   if copy(key,2,30)='geometry number   1 of the vib' then begin
    repeat
     readln(filvar,key);
    until copy(key,2,15)='dipole moment :';
    readln(filvar);
    readln(filvar,s15,s15,s15,dx[1,1]);
    readln(filvar,s15,s15,s15,dx[1,2]);
    readln(filvar,s15,s15,s15,dx[1,3]);
    imd:=1;
    repeat
     readln(filvar,key);
      if copy(key,2,15)='geometry number' then begin
       imd:=imd+1;
       repeat
        readln(filvar,key);
       until copy(key,2,15)='dipole moment :';
       readln(filvar);
       readln(filvar,s15,s15,s15,a);
       readln(filvar,s15,s15,s15,b);
       readln(filvar,s15,s15,s15,c);
       if imd<=3*nat then begin
        dx[imd,1]:=a;dx[imd,2]:=b;dx[imd,3]:=c;
       end else begin
        dx[imd,1]:=0.5*(dx[imd-3*nat,1]-a)/step;
        dx[imd,2]:=0.5*(dx[imd-3*nat,2]-b)/step;
        dx[imd,3]:=0.5*(dx[imd-3*nat,3]-c)/step;
        dx[imd-3*nat,1]:=dx[imd,1];
        dx[imd-3*nat,2]:=dx[imd,2];
        dx[imd-3*nat,3]:=dx[imd,3];
       end;
      end;
    until  imd=3*nat*2;
   end;

   goto l1;
 l6:
 nint:=imode;
 if imd>0 then begin
  for j:=1 to imode do begin
   for i:=1 to 3 do begin
    d[j,i]:=0.0;
    for k:=1 to 3*nat do d[j,i]:=d[j,i]+dx[k,i]*smx[k,j];
    d[j,i]:=d[j,i]/sqrt(2.0*e[j]/hartree)*0.02342179;
   end
  end;
  writeln(' Sum rules:');
  for i:=1 to 3 do begin
   a:=0.0;b:=0.0;c:=0.0;
   for j:=2 to nat do begin
    a:=a-dx[3*j-2,i];   b:=b-dx[3*j-1,i];   c:=c-dx[3*j,i];
   end;
  end;
 end;
end;

Procedure Reads5;{F.INP, Ftry}
label l2;
var
 imode,nint0,ii,i,j,jj,k,l:integer;ad,bd,cd:real;

begin
 energyerror:=0.1;
 {$I-}
 readln(filvar,nint,nat3,nat);
 allocatew(nat,nint);
 if IOResult<>0 then begin
  MessageDlg('Cannot read the file '+form2.opendialog1.filename+'.',mtinformation,[mbOK],0);
  readok:=false;
  exit;
 end;
 {$I+}
 n1:=1;n2:=nint;nint0:=nint;
 tmm(nint,n1,n2);
 nint:=n2-n1+1;
 for i:=1 to nat do begin
  readln(filvar,kind[i],x[i,1],x[i,2],x[i,3]);
  if form2.FTRY1.checked then at[i]:=atsy[kind[i]] else
  if kind[i]<=menold then at[i]:=atsyold[kind[i]] else at[i]:=' X';
 end;
 readln(filvar);
 for i:=1 to nat do begin
  for j:=1 to nint0 do begin
   readln(filvar,k,l,smx[3*(i-1)+1,j],smx[3*(i-1)+2,j],smx[3*(i-1)+3,j]);
  end;
 end;
 readln(filvar,nint0);
 jj:=0;
 i:=0;
 l2:
 i:=i+1;
 jj:=jj+1;
 if i<=nint0 then begin
  read(filvar,e[i]);
  if jj=6 then begin jj:=0;readln(filvar);end;
  goto l2;
 end;
 for j:=1 to nint0 do begin
  readln(filvar,d[j,1],d[j,2],d[j,3],m[j,1],m[j,2],m[j,3]);
  rs[j]:=d[j,1]*m[j,1]+d[j,2]*m[j,2]+d[j,3]*m[j,3];
  ds[j]:=d[j,1]*d[j,1]+d[j,2]*d[j,2]+d[j,3]*d[j,3];
 end;
 imode:=nint;
 if imode>n3 then imode:=nint;
 form2.label9.caption:=inttostr(nint)+' modes found';
end;

Procedure Reads6;{MOPAC}
label l1,l6,l8;
var namet:string[78];key:string[35];slovo:string[15];letter:string[1];
 s10:string[10];s15:string[15];
 ifound,ico,i,j,jj,zz:integer;a,b,c:real;
 frame:string[5];id,origine:string[5];
 element:string[10];
 z:array of integer;
 center:boolean;
 IOresold,idd,imode,jd,ml,mh:integer;
 ec:real;
 lgeo,lsmat,ldip:boolean;

procedure CHK;
 var cc:char;begin read(filvar,cc);if cc='1' then readln(filvar);end;

begin
 ifound:=0;
 lgeo:=false;lsmat:=false;ldip:=false;
l1:
   if eof(filvar) then begin
    goto l6;
   end;
   readln(filvar,key);
   {        1234567890123456789012345678901234567890}
   if  key='         ORIENTATION OF MOLECULE IN' then begin
    lgeo:=true;
    for i:=1 to 1 do begin chk;readln(filvar);end;
    i:=0;
    assign(fx,'tem.scr');
    rewrite(fx);

    repeat
     i:=i+1;
     {$I-}
     chk;read(filvar,idd);
     IOresold:=IOresult;
     if IOresold=0 then begin
      readln(filvar,zz,x1,x2,x3);
      writeln(fx,zz,' ',x1,' ',x2,' ',x3);
     end else readln(filvar);
     {$I+}
    until IOresold<>0;
    nat:=i-1;
    close(fx);
    allocatew(nat,nat*3);
    reset(fx);
    for i:=1 to nat do readln(fx,z[i],x[i,1],x[i,2],x[i,3]);
    close(fx);

    setatomlb(nat);
    setlength(z,nat+1);
    for i:=1 to nat do q[i]:=0.0;
    ml:=1;mh:=3*nat;
    tmm(3*nat,ml,mh);
   end;
   {                   1234567890123456789012345678901234567890}
   if  (copy(key,12,13)='MASS-WEIGHTED')then begin
{  if  (copy(key,12,13)='NORMAL COORDI')then begin}
    for i:=1 to 3 do begin chk;readln(filvar);end;
    imode:=0;
    i:=0;
    chk;
    l8:imode:=imode+1;
    i:=i+1;
    read(filvar,ec);
    if (imode>=ml) and (imode<=mh) then e[imode-ml+1]:=ec;
    if (imode<mh) and (i<6) then  goto l8;
    imode:=imode-i+1;
    {imode: starting mode on the line}
    chk;readln(filvar);
    for j:=1 to nat do begin
     chk;read(filvar,idd);
     for jj:=imode to imode+i-1 do begin
      read(filvar,ec);
      if (jj>=ml) and (jj<=mh) then smx[(j-1)*3+1,jj-ml+1]:=ec;
     end;
     readln(filvar);
     chk;read(filvar,idd);
     for jj:=imode to imode+i-1 do begin
      read(filvar,ec);
      if (jj>=ml) and (jj<=mh) then smx[(j-1)*3+2,jj-ml+1]:=ec;
     end;
     readln(filvar);
     chk;read(filvar,idd);
     for jj:=imode to imode+i-1 do begin
      read(filvar,ec);
      if (jj>=ml) and (jj<=mh) then smx[(j-1)*3+3,jj-ml+1]:=ec;
     end;
     readln(filvar);
    end;
    if imode+i<mh then begin
     imode:=imode+i-1;
     for i:=1 to 3 do begin chk;readln(filvar);end;
     i:=0;
     goto l8;
    end;
    lsmat:=true;
    if (lsmat and lgeo) and ldip then goto l6;
   end; {matrix}
   if  (copy(key,12,13)='FREQUENCIES, ')then begin
    i:=0;
    repeat
     read(filvar,id);
     if id=' DIPX' then begin
      read(filvar,id);
      i:=i+1;
      j:=i+5;
      if j>mh then j:=mh;
      {X-component:}
      for jj:=i to j do begin
       read(filvar,ec);if (jj>=ml) and (jj<=mh) then d[jj-ml+1,1]:=ec;
      end;readln(filvar);
      {Y-component:}
      read(filvar,id,id);
      for jj:=i to j do begin
       read(filvar,ec);if (jj>=ml) and (jj<=mh) then d[jj-ml+1,2]:=ec;
      end;readln(filvar);
      {Z-component:}
      read(filvar,id,id);
      for jj:=i to j do begin
       read(filvar,ec);if (jj>=ml) and (jj<=mh) then d[jj-ml+1,3]:=ec;
      end;readln(filvar);
      i:=j;
     end else readln(filvar);{if DIPX}
    until jj=mh;
    ldip:=true;
   end; {Dipoles}
   goto l1;
   l6:
   nint:=mh-ml+1;
   for i:=1 to nat do begin
    case z[i] of 1:begin kind[i]:=4;at[i]:='H ';end;
                 6:begin kind[i]:=1;at[i]:='C ';end;
                 7:begin kind[i]:=3;at[i]:='N ';end;
                 8:begin kind[i]:=2;at[i]:='O ';end;
                 9:begin kind[i]:=10;at[i]:='F ';end;
    end;
   end;
end;

Procedure Reads7;{Gaussian 92 or 94}
label l1,l6,l8;
var namet:string[78];key:string[40];letter:string[1];
 s10:string[10];s15:string[15];
 ifound,imode,ico,i,j,k,l,lc6,jj:integer;a,b,c:real;
 frame:string[5];origine:string[5];
 id:string[4];s7:string[7];s22:string[22];s2:string[2];
 element:integer;
 linear:boolean;

begin
 ifound:=0;
l1:
   if eof(filvar) then begin
    goto l6;
   end;
   read(filvar,key);
{                        1234567890123456789012345678901234567890}
   if  (copy(key,20,20)='Standard orientation')or
       (copy(key,19,20)='Z-Matrix orientation') then begin
    readln(filvar);
    for i:=1 to 4 do readln(filvar);
    i:=0;
    assign(fx,'tem.scr');
    rewrite(fx);
    repeat
     i:=i+1;
     {$I-}
     readln(filvar,j,j,x1,x2,x3);
     writeln(fx,j,' ',x1,' ',x2,' ',x3);
     {$I+}
    until IOresult<>0;
    nat:=i-1;
    close(fx);
    allocatew(nat,nat*3);
    reset(fx);
    for i:=1 to nat do readln(fx,kind[i],x[i,1],x[i,2],x[i,3]);
    close(fx);

    setatomlb(nat);
    for i:=1 to nat do q[i]:=0.0;
    for j:=1 to nat do begin
     element:=kind[j];kind[j]:=0;
     at[j]:='X ';
     if element=6  then begin kind[j]:=1;at[j]:='C ';end;
     if element=8  then begin kind[j]:=2;at[j]:='O ';end;
     if element=1  then begin kind[j]:=4;at[j]:='H ';end;
     if element=7  then begin kind[j]:=3;at[j]:='N ';end;
     if element=9  then begin kind[j]:=10;at[j]:='F ';end;
     if element=17 then begin kind[j]:=11;at[j]:='Cl';end;
     if element=16 then begin kind[j]:=5 ;at[j]:='S ';end;
     if element=15 then begin kind[j]:=9 ;at[j]:='P ';end;
     if kind[j]=0 then showmessage('unknown atom '+inttostr(i)+' '+inttostr(element));
    end;
    linear:=linmol(x);
   end;
   {                  1234567890123456789012345678901234567890}
   if copy(key,2,20)='Total atomic charges' then begin
    readln(filvar);
    readln(filvar);
    for i:=1 to nat do readln(filvar,s7,q[i]);
   end;
     {               1234567890123456789012345678901234567890}
   if copy(key,2,8)='SCF Done' then begin
    readln(filvar);
   end;
   {                  1234567890123456789012345678901234567890}
   if copy(key,2,24)='Harmonic frequencies (cm' then begin
    readln(filvar);
    if linear then tmm(3*nat-5,n1,n2) else tmm(3*nat-6,n1,n2);
    for i:=1 to 4 do readln(filvar);
    imode:=0;
    i:=0;
    l8:
    imode:=imode+1;
    i:=i+1;
    if i=1 then read(filvar,s22);
    read(filvar,a);
    if (imode>=n1) and (imode<=n2) then begin
     e[imode-n1+1]:=a;
    end;
    lc6:=6;if linear then lc6:=5;
    if (imode<3*nat-lc6) and (i<5) then  goto l8;
    for j:=1 to 3 do readln(filvar);
    read(filvar,s22);
    for j:=1 to i do begin
     read(filvar,a);
     a:=a/sqrt(2.0*Pi)/abs(e[imode-i+j-n1+1]);
     if (imode-i+j>=n1) and (imode-i+j<=n2) then dr[imode-i+j-n1+1]:=a;
    end;
    readln(filvar);
    read(filvar,s22);
    for j:=1 to i do begin
     read(filvar,a);
     if (imode-i+j>=n1) and (imode-i+j<=n2) then ri[imode-i+j-n1+1]:=a;
    end;
    readln(filvar);
    read(filvar,s22);
    for j:=1 to i do begin
     read(filvar,a);
     if (imode-i+j>=n1) and (imode-i+j<=n2) then pr[imode-i+j-n1+1]:=a;
    end;
    readln(filvar);
    readln(filvar);
    for j:=1 to 3*nat do begin
     read(filvar,s22);
     for jj:=1 to i do begin
      read(filvar,a);
      if (imode-i+jj>=n1) and (imode-i+jj<=n2) then
                           smx[j,imode-i+jj-n1+1]:=a;
     end;
     readln(filvar);
    end;
    if imode<3*nat-lc6 then begin
     for i:=1 to 2 do readln(filvar);i:=0;goto l8;
    end;
    goto l6;
   end;{S-matrix}
   readln(filvar);
   goto l1;
 l6:
 nint:=n2-n1+1;
end;


Procedure Reads9;{Gaussian 98}
label l1,l6,l8,lnext,l9;
var namet:string[78];key:string[80];letter:string[1];
 s10:string[10];s15:string[15];s13:string[13];
 ifound,imode,ico,i,j,k,l,lc6,jj,idum:integer;a,b,c:real;
 frame:string[5];origine:string[5];
 id:string[4];s7:string[7];s22:string[22];  s16:string[16];
 i1,i2,code,ii ,jdum,element:integer;
 linear:boolean;ax,ay,az:real;s2:string[2];

begin
 ifound:=0;
l1:
   if eof(filvar) then begin
    goto l6;
   end;
   readln(filvar,key);
{                       1234567890123456789012345678901234567890}
   if  (copy(key,26,20)='Standard orientation') or
       (copy(key,26,20)='Z-Matrix orientation') or
       (copy(key,27,18)='Input orientation:') then begin
    for i:=1 to 4 do readln(filvar);
     assign(fx,'tem.scr');
    rewrite(fx);
    i:=0;
    repeat
     i:=i+1;
     {$I-}
     readln(filvar,j,j,idum,x1,x2,x3);
     writeln(fx,j,' ',x1,' ',x2,' ',x3);
     {$I+}
    until IOresult<>0;
    nat:=i-1;
    close(fx);
    allocatew(nat,nat*3);
    reset(fx);
    for i:=1 to nat do readln(fx,x[i,1],x[i,2],x[i,3]);
    close(fx);

    setatomlb(nat);
    for i:=1 to nat do q[i]:=0.0;
    for j:=1 to nat do begin
     element:=kind[j];kind[j]:=0;at[j]:='X ';
     if element=6  then begin kind[j]:=1;at[j]:='C ';end;
     if element=8  then begin kind[j]:=2;at[j]:='O ';end;
     if element=1  then begin kind[j]:=4;at[j]:='H ';end;
     if element=7  then begin kind[j]:=3;at[j]:='N ';end;
     if element=9  then begin kind[j]:=10;at[j]:='F ';end;
     if element=17 then begin kind[j]:=11;at[j]:='Cl';end;
     if element=16 then begin kind[j]:=5 ;at[j]:='S ';end;
     if element=15 then begin kind[j]:=9 ;at[j]:='P ';end;
     if kind[j]=0 then showmessage('unknown atom '+inttostr(i)+' '+inttostr(element));
    end;
    linear:=linmol(x);
   end;

   if copy(key,2,24)='Harmonic frequencies (cm' then begin
    if linear then tmm(3*nat-5,n1,n2) else tmm(3*nat-6,n1,n2);
    i1:=1;
    l8:
    i2:=i1+2;if i2>n2 then i2:=n2;
    repeat
     read(filvar,s16);
     if copy(s16,2,7)='Frequen' then for j:=i1 to i2 do read(filvar,e[j]);
     if copy(s16,2,7)='IR Inte' then begin
      for j:=i1 to i2 do read(filvar,dr[j]);
      for j:=i1 to i2 do dr[j]:=dr[j]/sqrt(2.0*Pi)/abs(e[j]+0.00001);
     end;
     if copy(s16,2,7)='Raman A' then for j:=i1 to i2 do read(filvar,ri[j]);
     if copy(s16,2,7)='Depolar' then for j:=i1 to i2 do read(filvar,pr[j]);
     if s16=' Dip. str.   -- ' then begin for j:=i1 to i2 do begin
      read(filvar,s10);read(filvar,s13);
      {$R-}val(s10,a,code);{$R-}if code<>0 then a:=0;
      dr[j]:=a;
     end;end;
     if s16=' Rot. str.   -- ' then begin for j:=i1 to i2 do begin
      read(filvar,s10);read(filvar,s13);
      {$R-}val(s10,a,code);{$R-}if code<>0 then a:=0;
      rr[j]:=a;
     end;end;
     readln(filvar);
    until copy(s16,2,7)='Atom AN';
    for j:=1 to nat do begin
     read(filvar,idum,jdum);for jj:=i1 to i2 do read(filvar,smx[3*(j-1)+1,jj],smx[3*(j-1)+2,jj],smx[3*(j-1)+3,jj]);readln(filvar);
    end;
    if i2<n2 then begin
     i1:=i1+3;goto l8;
    end;
    goto l6;
   end;{S-matrix}
   goto l1;
 l6:
 nint:=n2-n1+1;
 {Intensity [km/mol]=sqrt(2pi)*v[cm-1]*D[Debye^2]}
end;

Procedure Reads10;{Short Gaussian 94 S-matrix}
label l1,l6,l8,lnext,l9;
var namet:string[78];key:string[80];letter:string[1];
 s10:string[10];s15:string[15];
 ifound,imode,ico,i,j,k,l,lc6,jj,idum:integer;a,b,c:real;
 frame:string[5];origine:string[5];
 id:string[4];s7:string[7];s22:string[22];  s16:string[16];
 ii ,jdum,element:integer;
 linear:boolean;ax,ay,az:real;s2:string[2];

begin
 ifound:=0;
l1:
   if eof(filvar) then begin
    goto l6;
   end;
   readln(filvar,key);
{                        1234567890123456789012345678901234567890}
   if  (copy(key,20,20)='Standard orientation') or
       (copy(key,19,20)='Z-Matrix orientation') then begin
    for i:=1 to 4 do readln(filvar);
    i:=0;
    assign(fx,'tem.scr');
    rewrite(fx);
    repeat
     i:=i+1;
     {$I-}
     readln(filvar,j,j,x1,x2,x3);  writeln(fx,j,' ',x1,' ',x2,' ',x3);
     {$I+}
    until IOresult<>0;
    nat:=i-1;
    close(fx);
    allocatew(nat,nat*3);
    reset(fx);
    for i:=1 to nat do readln(fx,kind[i],x[i,1],x[i,2],x[i,3]);
    close(fx);
    setatomlb(nat);
    for i:=1 to nat do q[i]:=0.0;
    for j:=1 to nat do begin
     element:=kind[j];kind[j]:=0;at[j]:='X ';
     if element=6  then begin kind[j]:=1;at[j]:='C ';end;
     if element=8  then begin kind[j]:=2;at[j]:='O ';end;
     if element=1  then begin kind[j]:=4;at[j]:='H ';end;
     if element=7  then begin kind[j]:=3;at[j]:='N ';end;
     if element=9  then begin kind[j]:=10;at[j]:='F ';end;
     if element=17 then begin kind[j]:=11;at[j]:='Cl';end;
     if element=16 then begin kind[j]:=5 ;at[j]:='S ';end;
     if element=15 then begin kind[j]:=9 ;at[j]:='P ';end;
     if kind[j]=0 then showmessage('unknown atom '+inttostr(i)+' '+inttostr(element));
    end;
    linear:=linmol(x);
   end;

   if copy(key,2,24)='Harmonic frequencies (cm' then begin
    if linear then tmm(3*nat-5,n1,n2) else tmm(3*nat-6,n1,n2);
    for ii:=1 to 2 do readln(filvar);
    imode:=0;
    i:=0;
    l8:for ii:=1 to 2 do readln(filvar);l9:
    imode:=imode+1;
    i:=i+1;
    if i=1 then read(filvar,s16);
    read(filvar,a);
    if (imode>=n1) and (imode<=n2) then begin
     e[imode-n1+1]:=a;
    end;
    lc6:=6;if linear then lc6:=5;
    if (imode<3*nat-lc6) and (i<3) then  goto l9;
    for j:=1 to 3 do readln(filvar);
    read(filvar,s16);
    for j:=1 to i do begin
     read(filvar,a);
     a:=a/sqrt(2.0*Pi)/abs(e[imode-i+j-n1+1]);
     if (imode-i+j>=n1) and (imode-i+j<=n2) then dr[imode-i+j-n1+1]:=a;
    end;
    readln(filvar);
    read(filvar,s16);
    for j:=1 to i do begin
     read(filvar,a);
     if (imode-i+j>=n1) and (imode-i+j<=n2) then ri[imode-i+j-n1+1]:=a;
    end;
    readln(filvar);
    read(filvar,s16);
    for j:=1 to i do begin
     read(filvar,a);
     if (imode-i+j>=n1) and (imode-i+j<=n2) then pr[imode-i+j-n1+1]:=a;
    end;
    readln(filvar);
    repeat
     read(filvar,s2);
     if(s2='  ')then goto lnext;
     readln(filvar);
    until s2=' ';
    lnext:
    for j:=1 to nat do begin
     read(filvar,idum,jdum);
     for jj:=1 to i do begin
      read(filvar,ax,ay,az);
      if (imode-i+jj>=n1) and (imode-i+jj<=n2) then begin
       smx[3*(j-1)+1,imode-i+jj-n1+1]:=ax;
       smx[3*(j-1)+2,imode-i+jj-n1+1]:=ay;
       smx[3*(j-1)+3,imode-i+jj-n1+1]:=az;
      end;
     end;
     readln(filvar);
    end;
    if imode<3*nat-lc6 then begin
     i:=0;goto l8;
    end;
    goto l6;
   end;{S-matrix}
   goto l1;
 l6:
 nint:=n2-n1+1;
end;

Procedure Reads11;{Gaussian 03}
label l1,l6,l8,lnext,l9;
var namet:string[78];key:string[80];letter:string[1];
 s10:string[10];s15:string[15];s13:string[13];
 ifound,imode,ico,i,j,k,l,lc6,jj,idum:integer;a,b,c:real;
 frame:string[5];origine:string[5];
 id:string[4];s7:string[7];s22:string[22];  s16:string[16];
 i1,i2,code,ii ,jdum,element:integer;
 linear:boolean;ax,ay,az:real;s2:string[2];

begin
 ifound:=0;
l1:
   if eof(filvar) then begin
    goto l6;
   end;
   readln(filvar,key);
{                       1234567890123456789012345678901234567890}
   if  (copy(key,26,20)='Standard orientation') or
       (copy(key,26,20)='Z-Matrix orientation') or
       (copy(key,27,18)='Input orientation:') then begin
    for i:=1 to 4 do readln(filvar);
    i:=0;
    assign(fx,'tem.scr');
    rewrite(fx);
    repeat
     i:=i+1;
     {$I-}
     readln(filvar,j,j,idum,x1,x2,x3); writeln(fx,j,' ',x1,' ',x2,' ',x3);
     {$I+}
    until IOresult<>0;
    nat:=i-1;
    close(fx);
    allocatew(nat,nat*3);
    reset(fx);
    for i:=1 to nat do readln(fx,kind[i],x[i,1],x[i,2],x[i,3]);
    close(fx);

    setatomlb(nat);
    for i:=1 to nat do q[i]:=0.0;
    for j:=1 to nat do begin
     element:=kind[j];kind[j]:=0;at[j]:='X ';
     if element=6  then begin kind[j]:=1;at[j]:='C ';end;
     if element=8  then begin kind[j]:=2;at[j]:='O ';end;
     if element=1  then begin kind[j]:=4;at[j]:='H ';end;
     if element=7  then begin kind[j]:=3;at[j]:='N ';end;
     if element=9  then begin kind[j]:=10;at[j]:='F ';end;
     if element=17 then begin kind[j]:=11;at[j]:='Cl';end;
     if element=16 then begin kind[j]:=5 ;at[j]:='S ';end;
     if element=15 then begin kind[j]:=9 ;at[j]:='P ';end;
     if kind[j]=0 then showmessage('unknown atom '+inttostr(i)+' '+inttostr(element));
    end;
    linear:=linmol(x);
   end;

   if copy(key,2,24)='Harmonic frequencies (cm' then begin
    if linear then tmm(3*nat-5,n1,n2) else tmm(3*nat-6,n1,n2);
    for j:=1 to n2 do for i1:=1 to 9 do sp8[j,i1]:=0;
    i1:=1;
    l8:
    i2:=i1+2;if i2>n2 then i2:=n2;
    repeat
     read(filvar,s16);
     if(s16<>'')then begin
      if copy(s16,2,14)='Frequencies --'                   then for j:=i1 to i2 do read(filvar,e[j]);
      if copy(s16,2, 8)=copy(spectraform.edit1.text,1, 8) then for j:=i1 to i2 do  read(filvar,sp8[j,1]);
      if copy(s16,2, 8)=copy(spectraform.edit2.text,1, 8) then for j:=i1 to i2 do  read(filvar,sp8[j,2]);
      if copy(s16,2, 8)=copy(spectraform.edit3.text,1, 8) then for j:=i1 to i2 do  read(filvar,sp8[j,3]);
      if copy(s16,2, 8)=copy(spectraform.edit4.text,1, 8) then for j:=i1 to i2 do  read(filvar,sp8[j,4]);
      if copy(s16,2, 8)=copy(spectraform.edit5.text,1, 8) then for j:=i1 to i2 do  read(filvar,sp8[j,5]);
      if copy(s16,2, 8)=copy(spectraform.edit6.text,1, 8) then for j:=i1 to i2 do  read(filvar,sp8[j,6]);
      if copy(s16,2, 8)=copy(spectraform.edit7.text,1, 8) then for j:=i1 to i2 do  read(filvar,sp8[j,7]);
      if copy(s16,2, 8)=copy(spectraform.edit8.text,1, 8) then for j:=i1 to i2 do  read(filvar,sp8[j,8]);
      if copy(s16,2, 8)=copy(spectraform.edit9.text,1, 8) then for j:=i1 to i2 do  read(filvar,sp8[j,9]);
     end;
     readln(filvar);
    until (copy(s16,2,7)='Atom AN') or (copy(s16,3,8)='Atom  AN');{g03 or g09 format}
    for j:=1 to nat do begin
     read(filvar,idum,jdum);for jj:=i1 to i2 do read(filvar,smx[3*(j-1)+1,jj],smx[3*(j-1)+2,jj],smx[3*(j-1)+3,jj]);readln(filvar);
    end;
    if i2<n2 then begin
     i1:=i1+3;goto l8;
    end;
    goto l6;
   end;{S-matrix}
   goto l1;
 l6:
 nint:=n2-n1+1;
 {Intensity [km/mol]=sqrt(2pi)*v[cm-1]*D[Debye^2]}
end;

Procedure Reads12;{Gaussian 09}
label l1,l6,l8,lnext,l9;
var namet:string[78];key:string[80];letter:string[1];
 s10:string[10];s15:string[15];s13:string[13];
 ifound,imode,ico,i,j,k,l,lc6,jj,idum,i8:integer;
 a,b,c:real;
 frame:string[5];origine:string[5];
 id:string[4];s7:string[7];s22:string[22];
 i1,i2,code,ii ,jdum,element:integer;
 linear:boolean;ax,ay,az:real;s2:string[2];

begin
 ifound:=0;
l1:
   if eof(filvar) then begin
    goto l6;
   end;
   readln(filvar,key);
{                       1234567890123456789012345678901234567890}
   if  (copy(key,26,20)='Standard orientation') or
       (copy(key,26,20)='Z-Matrix orientation') or
       (copy(key,27,18)='Input orientation:') then begin
    for i:=1 to 4 do readln(filvar);
    i:=0;
    assign(fx,'tem.scr');
    rewrite(fx);
    repeat
     i:=i+1;
     {$I-}
     readln(filvar,j,j,idum,x1,x2,x3); writeln(fx,j,' ',x1,' ',x2,' ',x3);
     {$I+}
    until IOresult<>0;
    nat:=i-1;
    close(fx);
    allocatew(nat,nat*3);
    reset(fx);
    for i:=1 to nat do readln(fx,kind[i],x[i,1],x[i,2],x[i,3]);
    close(fx);

    setatomlb(nat);
    for i:=1 to nat do q[i]:=0.0;
    for j:=1 to nat do begin
     element:=kind[j];kind[j]:=0;at[j]:='X ';
     if element=6  then begin kind[j]:=1;at[j]:='C ';end;
     if element=8  then begin kind[j]:=2;at[j]:='O ';end;
     if element=1  then begin kind[j]:=4;at[j]:='H ';end;
     if element=7  then begin kind[j]:=3;at[j]:='N ';end;
     if element=9  then begin kind[j]:=10;at[j]:='F ';end;
     if element=17 then begin kind[j]:=11;at[j]:='Cl';end;
     if element=16 then begin kind[j]:=5 ;at[j]:='S ';end;
     if element=15 then begin kind[j]:=9 ;at[j]:='P ';end;
     if kind[j]=0 then showmessage('unknown atom '+inttostr(i)+' '+inttostr(element));
    end;
    linear:=linmol(x);
   end;

   if copy(key,2,24)='Harmonic frequencies (cm' then begin
    if linear then tmm(3*nat-5,n1,n2) else tmm(3*nat-6,n1,n2);
    for j:=1 to n2 do for i1:=1 to 9 do sp8[j,i1]:=0;
    i1:=1;
    l8:
    i2:=i1+2;if i2>n2 then i2:=n2;
    i8:=13;
    repeat
     read(filvar,s15);
     if(s15<>'')then begin
      if copy(s15,2,14)='Frequencies --'                  then for j:=i1 to i2 do read(filvar,e[j]);
      if copy(s15,2, i8)=copy(spectraform.edit1.text,1, i8) then for j:=i1 to i2 do  read(filvar,sp8[j,1]);
      if copy(s15,2, i8)=copy(spectraform.edit2.text,1, i8) then for j:=i1 to i2 do  read(filvar,sp8[j,2]);
      if copy(s15,2, i8)=copy(spectraform.edit3.text,1, i8) then for j:=i1 to i2 do  read(filvar,sp8[j,3]);
      if copy(s15,2, i8)=copy(spectraform.edit4.text,1, i8) then for j:=i1 to i2 do  read(filvar,sp8[j,4]);
      if copy(s15,2, i8)=copy(spectraform.edit5.text,1, i8) then for j:=i1 to i2 do  read(filvar,sp8[j,5]);
      if copy(s15,2, i8)=copy(spectraform.edit6.text,1, i8) then for j:=i1 to i2 do  read(filvar,sp8[j,6]);
      if copy(s15,2, i8)=copy(spectraform.edit7.text,1, i8) then for j:=i1 to i2 do  read(filvar,sp8[j,7]);
      if copy(s15,2, i8)=copy(spectraform.edit8.text,1, i8) then for j:=i1 to i2 do  read(filvar,sp8[j,8]);
      if copy(s15,2, i8)=copy(spectraform.edit9.text,1, i8) then for j:=i1 to i2 do  read(filvar,sp8[j,9]);
     end;
     readln(filvar);
    until copy(s15,3,8)='Atom  AN';
    for j:=1 to nat do begin
     read(filvar,idum,jdum);for jj:=i1 to i2 do read(filvar,smx[3*(j-1)+1,jj],smx[3*(j-1)+2,jj],smx[3*(j-1)+3,jj]);readln(filvar);
    end;
    if i2<n2 then begin
     i1:=i1+3;goto l8;
    end;
    goto l6;
   end;{S-matrix}
   goto l1;
 l6:
 nint:=n2-n1+1;
 {Intensity [km/mol]=sqrt(2pi)*v[cm-1]*D[Debye^2]}
end;

procedure outputfin;
label l1;
const  Radius: array[0..14] of real
= (0.05,0.83,0.8,0.8,0.4,1.2,0.83,0.83,0.83,1.5,0.75,1.5,1.5,1.5,0.05);
var xt,norm,consts,C1,w2:real;
var i,ii,k,j,ij,n1,n3,ln,n:integer;
filvar:textfile;filename:string;
begin
 filename:='filef.inp';
 assignfile(filvar,filename);
 rewrite(filvar);
 writeln(filvar,nint:5,nint:5,nat:5);
 for i:=1 to nat do writeln(filvar,kind[i]:4,x[i,1]:10:5,x[i,2]:10:5,x[i,3]:10:5);
 writeln(filvar,' Atom Mode X-disp y-disp z-disp');
 for i:=1 to nat do begin
  for j:=1 to nint do begin
   writeln(filvar,i:5,j:5,smx[3*(i-1)+1,j]:12:6,smx[3*(i-1)+2,j]:12:6,smx[3*(i-1)+3,j]:12:6);
  end;
 end;
 writeln(filvar,nint);
 for j:=1 to nint do begin
  write(filvar,e[j]:12:3);if j mod 6=0 then writeln(filvar);
 end;
 closefile(filvar);

 if nint<>3*nat then exit;

 {make nex fc:}

 { filename:='UNITARY.CHK';
 for i:=1 to nint do begin
  for j:=1 to nint do begin
   smf[i,j]:=0;
   for ii:=1 to nint do    smf[i,j]:=smf[i,j]+smx[i,ii]*smx[j,ii];
  end;
 end;
 assignfile(filvar,filename);
 rewrite(filvar);
 N1:=1;N:=nint;
 l1:  N3:=N1+4;
      IF(N3>N)then N3:=N;
      for LN:=N1 to N do begin
       WRITE(filvar,LN:4);for J:=N1 to MIN(LN,N3) do WRITE(filvar,smf[LN,J]:14:6);
       writeln(filvar);
      end;
      N1:=N1+5;
      IF(N3<N)then GOTO l1;
 closefile(filvar);}
 c1:=1302.828;

 for i:=1 to nint do begin
  for j:=1 to nint do begin
   smf[i,j]:=0;
   for ii:=1 to nint do begin
    w2:=sqr(e[ii]/c1);  if e[ii]<0 then w2:=-w2;
    smf[i,j]:=smf[i,j]+smx[i,ii]*w2*smx[j,ii];
   end;
  end;
 end;
 CONSTS:=4.359828/0.5291772/0.5291772;
 for i:=1 to nint do begin
  for j:=1 to nint do begin
   smf[i,j]:=smf[i,j]*sqrt(zmass[(i+2) div 3]*zmass[(j+2) div 3])/CONSTS;
  end;
 end;

 filename:='FILE.FC';
 assignfile(filvar,filename);
 rewrite(filvar);
 N1:=1;N:=nint;
 l1:  N3:=N1+4;
      IF(N3>N)then N3:=N;
      for LN:=N1 to N do begin
       WRITE(filvar,LN:4);for J:=N1 to MIN(LN,N3) do WRITE(filvar,smf[LN,J]:14:6);
       writeln(filvar);
      end;
      N1:=N1+5;
      IF(N3<N)then GOTO l1;
 closefile(filvar);


end;

Procedure Reads13;{CASTEP phonon}
label l2;
var
 idum,imode,nint0,ii,i,j,jj,k,l:integer;
 ad,bd,cd,xn,yn,zn,adum,alpha,beta,gamma,o11,o12,o13,o22,o23,o33,sar,car,
 ca,sa,cb,sb,cg,sg,a,b,c,ab,ac,bc:real;
 uv:array[1..3,1..3] of real;
 st:string;

begin
 energyerror:=0.1;
 repeat
  readln(filvar,st);
  if copy(st,1,16)=' Number of ions ' then nat:=strtoint(copy(st,23,5));
  if copy(st,1,16)=' Number of branc' then nat3:=strtoint(copy(st,23,5));
  if copy(st,1,16)=' Number of wavev' then begin
   nwv:=strtoint(copy(st,23,5));
   nwv:=strtoint(InputBox(inttostr(nwv)+' wave vectors found','Input the required vector:','1'));
  end;
  if copy(st,1,16)=' Unit cell vecto' then for i:=1 to 3 do begin for j:=1 to 3 do read(filvar,uv[i,j]);readln(filvar);end;
 until copy(st,1,11)=' Fractional';
 nint:=nat3;
 n1:=1;n2:=nint;nint0:=nint;
 tmm(nint,n1,n2);
 nint:=n2-n1+1;
 a:=sqrt(sqr(uv[1,1])+sqr(uv[1,2])+sqr(uv[1,3]));
 b:=sqrt(sqr(uv[2,1])+sqr(uv[2,2])+sqr(uv[2,3]));
 c:=sqrt(sqr(uv[3,1])+sqr(uv[3,2])+sqr(uv[3,3]));
 ab:=uv[1,1]*uv[2,1]+uv[1,2]*uv[2,2]+uv[1,3]*uv[2,3];
 ac:=uv[1,1]*uv[3,1]+uv[1,2]*uv[3,2]+uv[1,3]*uv[3,3];
 bc:=uv[2,1]*uv[3,1]+uv[2,2]*uv[3,2]+uv[2,3]*uv[3,3];
 alpha:=180/pi*arccos(bc/b/c);
 beta:=180/pi*arccos(ac/a/c);
 gamma:=180/pi*arccos(ab/b/a);
 for i:=1 to nat do begin
  readln(filvar,idum,x[i,1],x[i,2],x[i,3],st);
  for j:=1 to MENDELEV do if (atsy[j]=copy(st,4,2))or(atsy[j]=copy(st,3,2)) then begin
   kind[i]:=j;at[i]:=atsy[j];
  end;
  zmass[i]:=strtofloat(copy(st,7,15));
  {alpha:=90;beta:=94.605;gamma:=90;a:=8.7211;b:=11.4222;c:=10.5027;}
  ca:=cos(pi*alpha/180);  sa:=sin(pi*alpha/180);
  cb:=cos(pi*beta /180);  sb:=sin(pi*beta /180);
  cg:=cos(pi*gamma/180);  sg:=sin(pi*gamma/180);
  car:=(cb*cg-ca)/(sb*sg);
  sar:=sqrt(1-car*car);
  o11:=a;
  o12:=b*cg;
  o13:=c*cb;
  o22:=b*sg;
  o23:=-c*sb*car;
  o33:=c*sb*sar;
  x[i,1]:=x[i,1]*o11+x[i,2]*o12+x[i,3]*o13;
  x[i,2]:=           x[i,2]*o22+x[i,3]*o23;
  x[i,3]:=                      x[i,3]*o33;
 end;
 repeat
  if eof(filvar) then begin showmessage('end of file');exit;end;
  readln(filvar,st);
 until (copy(st,6,5)='q-pt=') and (strtoint(copy(st,11,5))=nwv);
 for i:=1 to nint do readln(filvar,j,e[j]);
 readln(filvar);
 readln(filvar);
 {read real parts:}
 for j:=1 to nint0 do begin
  for i:=1 to nat do begin
   readln(filvar,k,l,smx[3*(i-1)+1,j],adum,smx[3*(i-1)+2,j],adum,smx[3*(i-1)+3,j],adum);
  end;
 end;
 for j:=1 to nint0 do begin
  for i:=1 to 3 do begin   d[j,i]:=0;m[j,i]:=0;end;
  rs[j]:=d[j,1]*m[j,1]+d[j,2]*m[j,2]+d[j,3]*m[j,3];
  ds[j]:=d[j,1]*d[j,1]+d[j,2]*d[j,2]+d[j,3]*d[j,3];
 end;
 imode:=nint;
 if imode>n3 then imode:=nint;
 form2.label9.caption:=inttostr(nint)+' modes found';
 outputfin;
end;


procedure outputfin2(var filvar1:textfile);
label l1,l2;
var xt,norm,consts,C1,w2:real;
var i,ii,k,j,ij,n1,n3,ln,n:integer;
filvar:textfile;filename:string;
s10:string[10];
begin

 n1:=1;
l2:n2:=min(n1+4,nint);
 readln(filvar1);
 readln(filvar1);
 for i:=1 to nint do begin
  read(filvar1,s10);for j:=n1 to n2 do read(filvar1,smf[i,j]);readln(filvar1);
 end;
 if(n2<nint)then begin
  n1:=min(n1+5,nint);
  goto l2;
 end;

 {c1:=1302.828;}
 CONSTS:=4.359828/0.5291772/0.5291772;
 for i:=1 to nint do for j:=1 to nint do
 smf[i,j]:=smf[i,j]*sqrt(zmass[(i+2) div 3]*zmass[(j+2) div 3])/548.58;

 filename:='FILE.FC';
 assignfile(filvar,filename);
 rewrite(filvar);
 N1:=1;N:=nint;
 l1:  N3:=N1+4;
      IF(N3>N)then N3:=N;
      for LN:=N1 to N do begin
       WRITE(filvar,LN:4);for J:=N1 to MIN(LN,N3) do WRITE(filvar,smf[LN,J]:14:6);
       writeln(filvar);
      end;
      N1:=N1+5;
      IF(N3<N)then GOTO l1;
 closefile(filvar);


end;


procedure outputfin3;
label l1;
var xt,norm,consts,C1,w2:real;
var i,ii,k,j,ij,n1,n3,ln,n:integer;
filvar:textfile;filename:string;
begin
 filename:='filef.inp';
 assignfile(filvar,filename);
 rewrite(filvar);
 writeln(filvar,nint:5,nint:5,nat:5);
 for i:=1 to nat do writeln(filvar,kind[i]:4,x[i,1]:10:5,x[i,2]:10:5,x[i,3]:10:5);
 writeln(filvar,' Atom Mode X-disp y-disp z-disp');
 for i:=1 to nat do begin
  for j:=1 to nint do begin
   writeln(filvar,i:5,j:5,smx[3*(i-1)+1,j]:12:6,smx[3*(i-1)+2,j]:12:6,smx[3*(i-1)+3,j]:12:6);
  end;
 end;
 writeln(filvar,nint);
 for j:=1 to nint do begin
  write(filvar,e[j]:12:3);if j mod 6=0 then writeln(filvar);
 end;
 closefile(filvar);
end;

Procedure Reads14;{CP2K output of vibrational analysis}
label l2,l3;
var
 idum,imode,nint0,ii,i,j,jj,k,l:integer;
 ad,bd,cd,xn,yn,zn,adum,alpha,beta,gamma,o11,o12,o13,o22,o23,o33,sar,car,
 ca,sa,cb,sb,cg,sg,a,b,c,ab,ac,bc:real;
 uv:array[1..3,1..3] of real;
 st:string;
 s22:string[22];
 s10:string[10];

begin
 energyerror:=0.1;
 repeat
  readln(filvar,st);
  if copy(st,29,10)=' - Atoms: ' then begin
   nat:=strtoint(copy(st,61,20));
   nat3:=3*nat;
   nint:=nat3;
   n1:=1;n2:=nint;nint0:=nint;
   tmm(nint,n1,n2);
  end;
  if copy(st,1,16)=' Number of branc' then nat3:=strtoint(copy(st,23,5));
  if copy(st,1,38)=' VIB| Hessian in cartesian coordinates' then outputfin2(filvar);
  if copy(st,1,21)='  Atom  Kind  Element' then begin
   readln(filvar,st);
   for i:=1 to nat do begin
    readln(filvar,st);
    kind[i]:=strtoint(copy(st,19,3));at[i]:=atsy[kind[i]];
    zmass[i]:=strtofloat(copy(st,68,13));
    x[i,1]:=strtofloat(copy(st,22,12));
    x[i,2]:=strtofloat(copy(st,34,12));
    x[i,3]:=strtofloat(copy(st,46,12));
   end;
  end;
 until (copy(st,1,67)=' VIB|                        NORMAL MODES - CARTESIAN DISPLACEMENTS') or eof(filvar);

 n1:=1;
l2:n2:=min(n1+2,nint);
 readln(filvar);
 readln(filvar);
 read(filvar,s22);
 for i:=n1 to n2 do {$I-}read(filvar,e[i]){$I-};if IOresult<>0 then goto l3;readln(filvar);
 readln(filvar,s10);
 readln(filvar,s10);
 readln(filvar,s10);
 readln(filvar,s10);
 for i:=1 to nat do begin
  read(filvar,s10);
  for j:=n1 to n2 do read(filvar,smx[3*(i-1)+1,j],smx[3*(i-1)+2,j],smx[3*(i-1)+3,j]);readln(filvar);
 end;
 readln(filvar,s10);
 if(n2<nint)then begin
  n1:=min(n1+3,nint);
  goto l2;
 end;
 l3:nint:=n2;

 for j:=1 to nint0 do begin
  for i:=1 to 3 do begin   d[j,i]:=0;m[j,i]:=0;end;
  rs[j]:=d[j,1]*m[j,1]+d[j,2]*m[j,2]+d[j,3]*m[j,3];
  ds[j]:=d[j,1]*d[j,1]+d[j,2]*d[j,2]+d[j,3]*d[j,3];
 end;
 imode:=nint;
 if imode>n3 then imode:=nint;
 form2.label9.caption:=inttostr(nint)+' modes found';
 outputfin3;
end;

Procedure outputsc;var xt,norm:real;var i,k,j:integer;
flename:string;fr,fn:textfile;cf,fi,rr,z1,z2,rs1,ds1:real;
begin
 flename:='file.sc';
 assignfile(fr,flename);
 assignfile(fn,'nicu.txt');
 rewrite(fr);
 rewrite(fn);
 writeln(fr,1,' 0');
 writeln(fr,1,' 0');
 writeln(fr,xm/10:11:6,ym/10:11:6,zm/10:11:6);
 writeln(fr,' ',nint+1,'  quantum states');
 writeln(fr);
 writeln(fr,1:4,0.0:15:7,' 0.0 0.0 0.0');
 for i:=1 to nint do begin     if (e[i])>0.05 then begin
  rr   :=(m[i,1]*m[i,1]+m[i,2]*m[i,2]+m[i,3]*m[i,3])/131e-8/131e-8;
  rs[i]:=d[i,1]*m[i,1]+d[i,2]*m[i,2]+d[i,3]*m[i,3];
  rs1:=rs[i]/131e-8*e[i]/sqrt(388);
  ds[i]:=d[i,1]*d[i,1]+d[i,2]*d[i,2]+d[i,3]*d[i,3];
  ds1:=ds[i]*e[i]*e[i]/388;
  if abs(rr*ds1)>0 then begin
   cf:=rs1/sqrt(rr*ds1);
   fi:=arccos(cf)*180/pi;
   z1:=rs1/sqrt(ds1);
   z2:= rs1/ds1;
  end else begin cf:=0;fi:=0;z1:=0;z2:=0;end;
  writeln(fn,i:4,e[i]:15:2,fi:10:1,cf:10:6,z1:10:5,z2:10:5);
 end;   end;
 j:=1;
 for i:=1 to nint do begin
  if abs(e[i])>0.05 then begin
   j:=j+1;
   writeln(fr,j:4,e[i]*planck*light/electron*100:15:7,' 0.0 0.0 0.0');
  end;
 end;
 writeln(fr);j:=1;
 for i:=1 to nint do begin
  if abs(e[i])>0.05 then begin
   j:=j+1;
   writeln(fr,j,' ',d[i,1]:10:6,d[i,2]:10:6,d[i,3]:10:6,
                          m[i,1]:13:9,m[i,2]:13:9,m[i,3]:13:9,' ',rs[i]:13);
  end;
 end;
 writeln(fr);
 writeln(fr,' 0');
 close(fr);
 close(fn);
end;

procedure outputxyz;
const  Radius: array[0..14] of real
= (0.05,0.83,0.8,0.8,0.4,1.2,0.83,0.83,0.83,1.5,0.75,1.5,1.5,1.5,0.05);
var xt,norm:real;var i,k,j,ij:integer;
filvar:textfile;filename:string;
begin
 filename:='file.x';
 assignfile(filvar,filename);
 rewrite(filvar);
 writeln(filvar,filename);
 writeln(filvar,nat);
 for i:=1 to nat do begin
  writeln(filvar,kind[i]:4,x[i,1]:10:5,x[i,2]:10:5,x[i,3]:10:5,
  bond[i,1]:5,bond[i,2]:5,bond[i,3]:5,bond[i,4]:5,0:3,0:3,0:3,q[i]:10:5);
 end;
 closefile(filvar);
end;




Procedure outputtable;var ds,rs,raman:real;i,j,ii:integer;filvar:textfile;
begin
 if spectraform.checkbox1.Checked then begin
  assignfile(filvar,changefileext(form2.opendialog1.filename,'.tab'));
 end else begin
  assignfile(filvar,'file.tab');
 end;
 rewrite(filvar);
 if form2.Gaussian031.checked or form2.Gaussian091.checked then begin
  writeln(filvar,'  NM   Energy ',copy(spectraform.edit1.Text,1,12),' ',
  copy(spectraform.edit2.Text,1,12),' ',copy(spectraform.edit3.Text,1,12),' ',
  copy(spectraform.edit4.Text,1,12),' ',copy(spectraform.edit5.Text,1,12),' ',
  copy(spectraform.edit6.Text,1,12),' ',copy(spectraform.edit7.Text,1,12),' ',
  copy(spectraform.edit8.Text,1,12),' ',copy(spectraform.edit9.Text,1,12));
 end else begin
  writeln(filvar,'Normal mode * dipole strength * rotatory strength');
 end;
 writeln(filvar,'      cm^-1         D^2               cgs*1e44');
 writeln(filvar,'--------------------------------------------------');
         {       1234567890123456789012345678901234567890}
 j:=0;
 for i:=1 to nint do begin
  if abs(e[i])>0.05 then begin
   j:=j+1;
   ds:=d[i,1]*d[i,1]+d[i,2]*d[i,2]+d[i,3]*d[i,3];
   rs:=m[i,1]*d[i,1]+m[i,2]*d[i,2]+m[i,3]*d[i,3];
   if (iss=9) then begin
    ds:=dr[i];
    rs:=rr[i];
    raman:=ri[i];
    writeln(filvar,j:4,e[i]:10:3,'    ',ds:13,'    ',rs:12,' ',raman:12);
   end else begin
    if form2.Gaussian031.checked or form2.Gaussian091.checked then begin
     write(filvar,j:4,e[i]:10:3);for ii:=1 to 9 do write(filvar,sp8[i,ii]:12,' '); writeln(filvar);
    end else begin
    {Intensity [km/mol]=sqrt(2pi)*v[cm-1]*D[Debye^2]}
     writeln(filvar,j:4,e[i]:10:3,'    ',ds:13,'    ',rs:12,' ',ri[i]:12);
    end;
   end;
  end;
 end;
 writeln(filvar,'--------------------------------------------------');
 closefile(filvar);
end;

Procedure bondtable;
const  Radius: array[0..14] of real
   {0     1    2   3  4    5   6    7   8    9   10   11  12  13  14}
= (0.05,0.83,0.8,0.8,0.4,1.2,0.83,0.83,0.83,1.5,0.75,1.5,1.5,1.5,0.05);
var i,j,k:integer;
begin
 for i:=1 to nat do begin
  ib[i]:=0;
  for j:=1 to 4 do bond[i,j]:=0;
 end;
 for i:=1 to nat do begin
  for j:=i+1 to nat do begin
   if sqrt(sqr(x[i,1]-x[j,1])+sqr(x[i,2]-x[j,2])+sqr(x[i,3]-x[j,3]))
    <radius[kind[i]]+radius[kind[j]] then begin
    if ib[i]+1<=8 then begin
     bond[i,ib[i]+1]:=j;
     ib[i]:=ib[i]+1;
    end;
    if ib[j]+1<=8 then begin
     bond[j,ib[j]+1]:=i;
     ib[j]:=ib[j]+1;
    end;
   end;
  end;
 end;
end;

Procedure bondtablenew;
const  Radius: array[0..MENDELEV] of real
   {Du   H   He}
= (0.05,0.4,0.8,
               {C}  {N}   {O}
0.83,0.80,0.8 ,0.8 ,0.8 ,0.83,0.83,0.83,1.5 ,1.40,
1.5 ,1.5 ,1.5 ,1.20,1.40,1.40,1.40,1.40,1.40,1.40,
1.5 ,1.5 ,1.5 ,1.40,1.40,1.40,1.40,1.40,1.40,1.40,
1.5 ,1.5 ,1.5 ,1.40,1.40,1.40,1.40,1.40,1.40,1.40,
1.5 ,1.5 ,1.5 ,1.40,1.40,1.40,1.40,1.40,1.40,1.40,
1.5 ,1.5 ,1.5 ,1.40,1.40,1.40,1.40,1.40,1.40,1.40,
1.5 ,1.5 ,1.5 ,1.40,1.40,1.40,1.40,1.40,1.40,1.40,
1.5 ,1.5 ,1.5 ,1.40,1.40,1.40,1.40,1.40,1.40,1.40,
1.5 ,1.5 ,1.5 ,1.40,1.40,1.40,1.40);
var i,j,k:integer;
begin
 for i:=1 to nat do begin
  ib[i]:=0;
  for j:=1 to 4 do bond[i,j]:=0;
 end;
 for i:=1 to nat do begin
  for j:=i+1 to nat do begin
   if sqrt(sqr(x[i,1]-x[j,1])+sqr(x[i,2]-x[j,2])+sqr(x[i,3]-x[j,3]))
    <radius[kind[i]]+radius[kind[j]] then begin
    if ib[i]+1<=8 then begin
    bond[i,ib[i]+1]:=j;
    ib[i]:=ib[i]+1;
    end;
    if ib[j]+1<=8 then begin
    bond[j,ib[j]+1]:=i;
    ib[j]:=ib[j]+1;
    end;
   end;
  end;
 end;
end;

END.